﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr184_1
{
    // Объявление делегата:
    delegate void MyDelegate(string txt);

    // Класс с событием: 
    class MyClass {
        // Объявление события: 
        public event MyDelegate MyEvent;
        // Метод для генерирования события: 
        public void RaiseMyEvent(string txt) {
            // Если для события предусмотрены обработчики: 
            if (MyEvent != null) {
                // Генерирование события:
                MyEvent(txt);
            }
        }
    }

    // Класс: 
    class Alpha {
        // Текстовое поле: 
        public string name;
        // Конструктор: 
        public Alpha(string txt) { 
            name = txt;
        }
        // Метод отображает сообщение: 
        public void show(string msg) {
            Console.WriteLine("Объект " + name + ":");
            Console.WriteLine(msg);
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта с событием:
            MyClass obj = new MyClass();
            // Создание объектов:
            Alpha A = new Alpha("A");
            Alpha B = new Alpha("B");
            // Попытка сгенерировать событие: 
            obj.RaiseMyEvent("1-e событие");
            // Добавление обработчика для события: 
            obj.MyEvent += A.show;
            // Генерирование события: 
            obj.RaiseMyEvent("2-e событие");
            Console.WriteLine();
            // Добавление обработчика для события: 
            obj.MyEvent += B.show;
            // Генерирование события: 
            obj.RaiseMyEvent("3-е событие");
            Console.WriteLine();
            // Удаление метода из списка обработчиков события: 
            obj.MyEvent -= A.show;
            // Генерирование события: 
            obj.RaiseMyEvent("4-e событие");
            Console.WriteLine();
            // Удаление методов из списка обработчиков события:
            obj.MyEvent -= A.show;
            obj.MyEvent -= B.show;
            // Попытка сгенерировать событие: 
            obj.RaiseMyEvent("5-e событие");
            // Создание экземпляра делегата:
            MyDelegate md = A.show;
            // Добавление метода в список вызовов 
            // экземпляра делегата: 
            md += B.show;
            // Добавление экземпляра делегата в список 
            // обработчиков события: 
            obj.MyEvent += md;
            // Генерирование события: 
            obj.RaiseMyEvent("6-е событие");
            // Задержка:
            Console.ReadLine();
        }
    }
}
